### Apache HTTP Server Version 1.3

# Module mod_asis

This module provides for sending files which contain their own HTTP headers.

Status: Base
Source File: mod_asis.c
Module Identifier: asis_module

## Summary

This module provides the handler `send-as-is` wich causes Apache to send the document without adding most of the usual HTTP headers.

This can be used to send any kind of data from the server, including redirects and other special HTTP responses, without requiring a cgi-script or an nph script.

For historical reasons, this module will also process any file with the mime type `httpd/send-as-is`.

## Directives

This module provides no directives.

## Usage

In the server configuration file, associate files with the `send-as-is` handler e.g.

> `AddHandler send-as-is asis`

The contents of any file with a `.asis` extension will then be sent by Apache to the client with almost no changes. Clients will need HTTP headers to be attached, so do not forget them. A Status: header is also required; the data should be the 3-digit HTTP response code, followed by a textual message.

Here's an example of a file whose contents are sent as is so as to tell the client that a file has redirected.

> `Status: 301 Now where did I leave that URL
> Location: http://xyz.abc.com/foo/bar.html
> Content-type: text/html
> <HTML>
> <HEAD>
> <TITLE>Lame excuses'R'us</TITLE>
> </HEAD>
> <BODY>
> <H1>Fred's exceptionally wonderful page has moved to
> <A HREF="http://xyz.abc.com/foo/bar.html">Joe's</A> site.
> </H1>
> </BODY>
> </HTML>`

Notes: the server always adds a Date: and Server: header to the data returned to the client, so these should not be included in the file. The server does not add a Last-Modified header; it probably should.

### Apache HTTP Server Version 1.3